#include <string>
#include "qr/qrerror.h"
#include "qr/container.h"
#define NOIMP
namespace kwlib{
#include "cppfl/base.h"
#include "cppfl/image.h"
};
#include <iostream>
using namespace std;
using namespace kwlib;

int decodeqr(string &s,const Bitmap8 &code)
{
	if (code.height<21) return -1;

	int height=code.height;

	Bitmap8 funcmask(code.size());
	Bitmap8 buf(code.size());
	funcmask.clear();

	Qr::Qr *qr = new Qr::Qr();
	qr->set_version((height-17)/4);
	qr->init_each_formatinfo_pattern_pixel();

	int x,y;
	int data=0;
	while(qr->each_formatinfo_pattern_pixel(0,&x,&y)){
		data<<=1;
		data|=code(x,y)^1;
	}
	qr->decode_formatinfo(data);
       
	qr->init_each_function_pattern_pixel();
	while(qr->each_function_pattern_pixel(&x,&y)){
		funcmask(x,y)=1;
	}
	for (y=0;y<height;y++) {
		for (x=0;x<height;x++) {
			int dx=0,dy=0;
			if (x>6) dx=1;
			if (y>6) dy=1;
			buf(x-dx,y-dy)=code(x,y)^(funcmask(x,y)==0 && qr->formatinfo->mask_pixel(y,x))?1:0;
			funcmask(x-dx,y-dy)=funcmask(x,y);
		}
	}


	height--;
    // read code from matrix
    data=0;
    int bit_count=0,word_count=0;
    int dir=-1;
    x=height-1;
    y=height-1;
    
    do{
        data<<=1;
        bit_count++;
        if(buf(x,y)==0)
            data|=1;
        if(!(bit_count%8)){
            if(qr->push_codedata(data))
                word_count++;
            data=0;
        }
        
        if(x&0x1){
            if(funcmask(x-1,y)==0)
                x--;
            else{
                do{
                    y+=dir;
                    if(y<0||y>=height){
                        x-=2;
                        dir*=-1;
                        y+=dir;
                        if(x<0)
                            break;
                    }
                }while(funcmask(x,y));
            }
        }
        else{
            x++;
            do{
                y+=dir;
                if(y>=0&&y<height){
                    if(!funcmask(x,y)){
                        break;
                    }
                    else if(!funcmask(x-1,y)){
                        x--;
                        break;
                    }
                    else{
                        y+=dir;
                    }
                }
                else{
                    x-=2;
                    dir*=-1;
                    y+=dir;
                    if(x<0)
                        break;
                }
            }while(funcmask(x,y));
        }
    }while(x>=0);
    
    if(data){
        if(qr->push_codedata(data))
            word_count++;
    }

	int errors=qr->decode_codedata();
	s=string((char*)qr->codedata->raw_data(),qr->codedata->byte_length);
	//cout << "level:" << qr->formatinfo->level << endl;
	//cout << bit_count << " bits."<< endl;
	//cout << "ERR:" << errors << endl;
	//cout << qr->codedata->byte_length << endl;
	//cout << s << endl;


	delete qr;

	return errors;
}
